on startMovie
  global gInit, quadro, CurX, CurY
  set quadro to [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]
  set CurX to 4
  set CurY to 4
  set gInit to 1
end

on MescolaQuadroCasualmente
  global quadro, CurX, CurY
  set quadro to [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
  repeat with n = 1 to 16
    set OK to 0
    repeat while OK = 0
      set dum to random(16)
      repeat with mm = 1 to 16
        if getAt(quadro, mm) = dum then
          set OK to 0
          exit repeat
          next repeat
        end if
        set OK to 1
      end repeat
    end repeat
    setAt(quadro, n, dum)
    if dum = 16 then
      set CurX to n mod 4
      if CurX = 0 then
        set CurX to 4
      end if
      set CurY to ((n - 1) / 4) + 1
    end if
  end repeat
end

on PezzoAdiacente offx, offy
  global quadro, CurX, CurY
  set dito to 516
  set nx to CurX + offx
  set nY to CurY + offy
  if (nx >= 1) and (nx <= 4) and (nY >= 1) and (nY <= 4) then
    return 1
  else
    return 0
  end if
end

on MescolaQuadro Diff
  global quadro, CurX, CurY, RAGAZZA
  set quadro to [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]
  set CurX to 4
  set CurY to 4
  repeat with quanti = 1 to Diff
    set vie to [0, 0, 0, 0]
    set nvie to 0
    if PezzoAdiacente(-1, 0) then
      set nvie to 1
      setAt(vie, nvie, CurX - 1 + ((CurY - 1) * 4))
    end if
    if PezzoAdiacente(1, 0) then
      set nvie to nvie + 1
      setAt(vie, nvie, CurX + 1 + ((CurY - 1) * 4))
    end if
    if PezzoAdiacente(0, -1) then
      set nvie to nvie + 1
      setAt(vie, nvie, CurX + ((CurY - 2) * 4))
    end if
    if PezzoAdiacente(0, 1) then
      set nvie to nvie + 1
      setAt(vie, nvie, CurX + (CurY * 4))
    end if
    set nuovo to getAt(vie, random(nvie))
    set ntemp to getAt(quadro, nuovo)
    setAt(quadro, nuovo, 16)
    set the castNum of sprite (20 + nuovo) to the number of cast (RAGAZZA & "16")
    setAt(quadro, CurX + ((CurY - 1) * 4), ntemp)
    set the castNum of sprite (20 + (CurX + ((CurY - 1) * 4))) to the number of cast (RAGAZZA & ntemp)
    set CurX to nuovo mod 4
    if CurX = 0 then
      set CurX to 4
    end if
    set CurY to ((nuovo - 1) / 4) + 1
    updateStage()
  end repeat
end

on RipristinaQuadro
  global quadro, RAGAZZA
  repeat with n = 1 to 16
    set the castNum of sprite (20 + n) to the number of cast (RAGAZZA & getAt(quadro, n))
  end repeat
  updateStage()
  cursoriQuadro()
end

on ControllaVincita
  global quadro, RAGAZZA
  set VINTO to 1
  repeat with n = 1 to 16
    if getAt(quadro, n) <> n then
      set VINTO to 0
      exit repeat
    end if
  end repeat
  if VINTO then
    repeat with n = 1 to 16
      puppetSprite(n + 20, 0)
      set the cursor of sprite (20 + n) to 0
    end repeat
    updateStage()
    go("VINTO" & RAGAZZA)
  end if
end

on cursoriQuadro
  global quadro, CurX, CurY
  repeat with n = 1 to 16
    set the cursor of sprite (20 + n) to 0
  end repeat
  CursoreAdiacente(-1, 0)
  CursoreAdiacente(1, 0)
  CursoreAdiacente(0, -1)
  CursoreAdiacente(0, 1)
end

on CursoreAdiacente offx, offy
  global quadro, CurX, CurY
  set dito to 516
  set nx to CurX + offx
  set nY to CurY + offy
  if (nx >= 1) and (nx <= 4) and (nY >= 1) and (nY <= 4) then
    set the cursor of sprite (20 + (nx + ((nY - 1) * 4))) to [dito, dito + 1]
  end if
end
